Attribute VB_Name = "HTMLParser"
Option Explicit

Public Const vbSpace As String = " ", vbSpace2 As String = "  "
Public Const vbSkip As String = "-"
Public Const vbEmptyDate As Date = 0

Public Type TagType
  Name As String
  Count As Long
  Fields() As String
  Values() As String
End Type

Public Type TagsType
  Last As Long
  Name As String
  TagDisabled As Boolean
  TagPosStart As Long
  TagPosEnd As Long
  TagOpen As Boolean
  TagOpenPosStart As Long
  TagOpenPosEnd As Long
  TagClose As Boolean
  TagClosePosStart As Long
  TagClosePosEnd As Long
  TagValue As Boolean
  TagValuePosStart As Long
  TagValuePosEnd As Long
  Text As String
  Attributes As TagType
End Type

Public Function StripHTML(ByVal HTML As String, Optional ByVal StripEntities As Boolean = True, Optional ByVal StripTags As Boolean = True, Optional ByVal StripSpaces As Boolean = True, Optional ByVal StripLineFeeds As Boolean = False) As String
Dim L As Long, P0 As Long, P As Long
If StripTags And Len(HTML) > 0 Then
  Const TagPrefix As String = "<", TagPostfix As String = ">", TagRemark As String = "<!--", TagRemarkEnd As String = "-->"
  Dim TagName As String
  L = Len(HTML)
  P0 = 1
  Do Until P0 > L
    P = InStr(P0, HTML, TagRemark)
    If P = 0 Or P > L Then Exit Do
    P0 = P
    P = InStr(P0 + Len(TagRemark), HTML, TagRemarkEnd)
    If P = 0 Or P > L Then P = L + 1
    P = P + Len(TagRemarkEnd)
    If P <= L Then
      Mid$(HTML, P0, L - P + 1) = Mid$(HTML, P, L - P + 1)
    End If
    L = L - (P - P0)
  Loop
  P0 = 1
  Do Until P0 > L
    P = InStr(P0, HTML, TagPrefix)
    If P = 0 Or P > L Then Exit Do
    P0 = P
    P = InStr(P0 + Len(TagPrefix), HTML, TagPostfix)
    If P = 0 Or P > L Then P = L + 1
    P = P + Len(TagPostfix)
    If P <= L Then
      If StripLineFeeds Then
        Mid$(HTML, P0, L - P + 1) = Mid$(HTML, P, L - P + 1)
      Else
        TagName = Mid$(HTML, P0 + Len(TagPrefix), P - P0 - Len(TagPrefix) - Len(TagPostfix)) & vbSpace
        TagName = UCase$(Trim$(Left$(TagName, InStr(TagName, vbSpace) - 1)))
        Select Case TagName
          Case "P", "BR", "BR/", "HR"
            Mid$(HTML, P0, Len(vbNullChar)) = vbNullChar
            If P <= L Then Mid$(HTML, P0 + Len(vbNullChar), L - P + 1) = Mid$(HTML, P, L - P + 1)
            L = L - (P - P0) + Len(vbNullChar)
          Case Else
            Mid$(HTML, P0, L - P + 1) = Mid$(HTML, P, L - P + 1)
        End Select
      End If
    End If
    L = L - (P - P0)
  Loop
  HTML = Left$(HTML, L)
End If
If StripEntities And Len(HTML) > 0 Then
  Const EntityPrefix As String = "&", EntityPostfix As String = ";", EntityNumeric As String = "#"
  Const Entities As String = "#NBSP#160#QUOT#34#AMP#38#LT#60#GT#62#IEXCL#161#CENT#162#POUND#163#CURREN#164#YEN#165#BRVBAR#166#BRKBAR#166#SECT#167#COPY#169#REG#174#LAQUO#171#RAQUO#187#DEG#176#PLUSMN#177#SUP1#185#SUP2#178#SUP3#179#PARA#182#MIDDOT#183#FRAC12#189#FRAC14#188#FRAC34#190#IQUEST#191#TIMES#215#DIVIDE#247#ENSP#8194#EMSP#8195#THINSP#8201#NDASH#8211#MDASH#8212#LSQUO#8216#RSQUO#8217#SBQUO#8218#LDQUO#8220#RDQUO#8221#BDQUO#8222#PERMIL#8240#LSAQUO#8249#RSAQUO#8250#FNOF#402#BULL#8226#HELLIP#8230#TRADE#8482#"
  Const EntityEmpty As String = ""
  Const EntityFind  As String = ""
  Const EntitySubst As String = " "
  Dim E As String, I As Long
  L = Len(HTML)
  P0 = 1
  Do Until P0 > L
    P = InStr(P0, HTML, EntityPrefix)
    If P = 0 Or P > L Then Exit Do
    If Mid$(HTML, P + Len(EntityPrefix), Len(vbSpace)) = vbSpace Then
      P0 = P + Len(EntityPrefix)
    Else
      E = vbNullString
      P0 = P
      P = InStr(P0 + Len(EntityPrefix), HTML, EntityPostfix)
      If P = 0 Or P > L Then
        P = InStr(P0 + Len(EntityPrefix), HTML, vbSpace)
        If P = 0 Or P > L Then
          P = 0
          P0 = P0 + 1
        Else
          E = Mid$(HTML, P0 + Len(EntityPrefix), P - (P0 + Len(EntityPrefix)))
          P = P + Len(vbSpace)
        End If
      Else
        E = Mid$(HTML, P0 + Len(EntityPrefix), P - (P0 + Len(EntityPrefix)))
        P = P + Len(EntityPostfix)
      End If
      If Len(E) > 0 Then
        If Left$(E, Len(EntityNumeric)) = EntityNumeric Then
          E = ChrW$(Val(Mid$(E, 2)))
        Else
          I = InStr(Entities, "#" & UCase$(E) & "#")
          If I = 0 Then
            E = vbNullString
          Else
            I = I + Len(E) + 2
            E = ChrW$(Val(Mid$(Entities, I, InStr(I, Entities, "#") - I)))
          End If
        End If
        If InStr(EntityEmpty, E) > 0 Then E = vbNullString
        If Len(E) > 0 Then
          I = InStr(EntityFind, E)
          If I > 0 Then E = Mid$(EntitySubst, I, Len(E))
        End If
      End If
      Mid$(HTML, P0, Len(E)) = E
      If P <= L Then Mid$(HTML, P0 + Len(E), L - P + 1) = Mid$(HTML, P, L - P + 1)
      L = L - (P - P0) + Len(E)
    End If
  Loop
  HTML = Left$(HTML, L)
End If
If StripSpaces And Len(HTML) > 0 Then
  HTML = Replace$(HTML, vbCrLf, vbSpace)
  HTML = Replace$(HTML, vbCr, vbSpace)
  HTML = Replace(HTML, vbLf, vbSpace)
  HTML = Replace$(HTML, vbTab, vbSpace)
  HTML = Trim$(HTML)
  If Len(HTML) > 0 Then
    L = 0
    While Len(HTML) <> L
      L = Len(HTML)
      HTML = Replace$(HTML, vbSpace2, vbSpace)
    Wend
  End If
  If Not StripLineFeeds Then
    HTML = Replace$(HTML, vbSpace & vbNullChar, vbNullChar)
    HTML = Replace$(HTML, vbNullChar & vbSpace, vbNullChar)
    P = 1
    L = Len(HTML)
    Do While L >= P
      P0 = 0
      If Mid$(HTML, P, Len(vbNullChar)) = vbNullChar Then
        P = P + 1
        P0 = 1
      End If
      If Mid$(HTML, L - Len(vbNullChar) + 1, Len(vbNullChar)) = vbNullChar Then
        L = L - 1
        P0 = 1
      End If
      If P0 = 0 Then Exit Do
    Loop
    If L < P Then L = P - 1
    HTML = Mid$(HTML, P, L - P + 1)
    HTML = Replace$(HTML, vbNullChar, vbNewLine)
  End If
End If
StripHTML = HTML
End Function

Public Sub ParseHTML(HTML As String, ByRef Tags() As TagsType, Optional ByVal AutoParseTag As Boolean = False, Optional ByVal StoreText As Boolean = False)
Const TagStart As String = "<", TagEnd As String = ">", TagClose As String = "/", TagRemark As String = "!--"
Dim TagsCount As Long, P0 As Long, P As Long, I0 As Long, I As Long, N As Long, TagName As String, fTagClosing As Boolean, fTagStandalone As Boolean, fTagDisabled As Boolean, S As String
ReDim Tags(0)
P0 = 1
Do Until P0 > Len(HTML)
  If fGlobalCancel Then
    ReDim Tags(0)
    Exit Do
  End If
  P = InStr(P0, HTML, TagStart)
  If P = 0 Then Exit Do
  fTagClosing = False
  fTagStandalone = False
  fTagDisabled = False
  P0 = P + Len(TagStart)
  I0 = P
  I = InStr(I0 + Len(TagStart), HTML, TagEnd)
  If I = 0 Then I = Len(HTML) + 1
  fTagClosing = (Mid$(HTML, I0 + 1, Len(TagClose)) = TagClose)
  If Not fTagClosing Then fTagStandalone = (Mid$(HTML, I - Len(TagClose), Len(TagClose)) = TagClose)
  If fTagClosing Then
    S = UCase$(Mid$(HTML, I0 + Len(TagStart) + Len(TagClose), I - I0 - Len(TagStart) - Len(TagClose)))
  Else
    If fTagStandalone Then
      S = UCase$(Mid$(HTML, I0 + Len(TagStart), I - Len(TagClose) - I0 - Len(TagStart)))
    Else
      S = UCase$(Mid$(HTML, I0 + Len(TagStart), I - I0 - Len(TagStart)))
    End If
  End If
  S = Replace$(S, vbCrLf, vbSpace)
  S = Replace$(S, vbTab, vbSpace)
  S = Replace$(S, vbCr, vbSpace)
  S = Replace$(S, vbLf, vbSpace)
  If Len(S) > 0 Then
    P = 0
    While Len(S) <> P
      P = Len(S)
      S = Replace$(S, vbSpace2, vbSpace)
    Wend
  End If
  S = Trim$(S) & vbSpace
  TagName = Left$(S, InStr(S, vbSpace) - 1)
  If Left$(TagName, Len(TagRemark)) = TagRemark Then
    TagName = TagRemark
    fTagStandalone = True
    fTagClosing = False
    I = InStr(I0 + Len(TagStart) + Len(TagRemark), HTML, "-->")
    If I = 0 Then I = Len(HTML) + 1
    I = I + 2
  End If
  If Left$(TagName, 1) = "!" Then fTagDisabled = True
  If Left$(TagName, 1) = "!" And TagName <> TagRemark Then TagName = Mid$(TagName, 2)
  If fTagClosing Then
    If Len(TagName) = 0 Then
      N = TagsCount + 1
    Else
      For N = TagsCount To 1 Step -1
        If (Tags(N).Name = TagName) And (Tags(N).TagOpen) And (Not Tags(N).TagClose) Then Exit For
      Next N
      If N = 0 Then N = TagsCount + 1
    End If
  Else
    N = TagsCount + 1
  End If
  If N > TagsCount Then
    TagsCount = TagsCount + 1
    If TagsCount > UBound(Tags) Then ReDim Preserve Tags(0 To UBound(Tags) + 100)
    Tags(N).Name = TagName
    Tags(N).TagDisabled = fTagDisabled
  End If
  If fTagStandalone Then
    Tags(N).Last = N
    Tags(N).TagPosStart = I0
    Tags(N).TagPosEnd = I + Len(TagClose) - 1
    If Tags(N).Name <> TagRemark Then
      Tags(N).TagOpen = True
      Tags(N).TagOpenPosStart = Tags(N).TagPosStart
      Tags(N).TagOpenPosEnd = Tags(N).TagPosEnd
      Tags(N).TagClose = True
      Tags(N).TagClosePosStart = Tags(N).TagPosStart
      Tags(N).TagClosePosEnd = Tags(N).TagPosEnd
    End If
  Else
    If fTagClosing Then
      Tags(N).Last = TagsCount
      Tags(N).TagClose = True
      Tags(N).TagClosePosStart = I0
      Tags(N).TagClosePosEnd = I + Len(TagClose) - 1
      Tags(N).TagValuePosEnd = I0 - 1
      Tags(N).TagPosEnd = I + Len(TagClose) - 1
    Else
      Tags(N).Last = N
      Tags(N).TagOpen = True
      Tags(N).TagOpenPosStart = I0
      Tags(N).TagOpenPosEnd = I + Len(TagClose) - 1
      Tags(N).TagValue = True
      Tags(N).TagValuePosStart = I + Len(TagClose)
      Tags(N).TagPosStart = I0
      Tags(N).TagPosEnd = I + Len(TagClose) - 1
    End If
  End If
  P0 = I + Len(TagClose)
Loop
ReDim Preserve Tags(0 To TagsCount)
Dim Tag As TagType
For I = 1 To TagsCount
  If Tags(I).TagValue Then
    If Tags(I).TagValuePosStart = 0 Or Tags(I).TagValuePosEnd = 0 Then
      Tags(I).TagValue = False
      Tags(I).TagValuePosStart = 0
      Tags(I).TagValuePosEnd = 0
    End If
  End If
  If AutoParseTag Then
    If Not Tags(I).TagDisabled And Tags(I).TagOpen Then
      Call ParseTag(Mid$(HTML, Tags(I).TagOpenPosStart, Tags(I).TagOpenPosEnd - Tags(I).TagOpenPosStart + 1), Tags(I).Attributes)
    End If
  End If
  If StoreText Then
    If Not Tags(I).TagDisabled And Tags(I).TagValue Then
      If I = 68 Then Stop
      Tags(I).Text = StripHTML(Mid$(HTML, Tags(I).TagValuePosStart, Tags(I).TagValuePosEnd - Tags(I).TagValuePosStart + 1))
    End If
  End If
Next I
I0 = FreeFile: Open "C:\output.htm" For Output As #I0: Print #I0, HTML;: Close #I0
I0 = FreeFile: Open "C:\output.tab" For Output As #I0
Print #I0, Replace$("Num#Last#T#D#Dec#TS#TE#TO#TOS#TOE#TC#TCS#TCE#TV#TVS#TVE#Hex#TS#TE#TO#TOS#TOE#TC#TCS#TCE#TV#TVS#TVE#A#Text#HTML", "#", vbTab)
For I = 1 To UBound(Tags)
  Print #I0, Trim$(Str$(I)); vbTab;
  Print #I0, Trim$(Str$(Tags(I).Last)); vbTab;
  Print #I0, Tags(I).Name; vbTab;
  Print #I0, IIf(Tags(I).TagDisabled, "[x]", "[  ]"); vbTab;
  Print #I0, vbSkip; vbTab;
  Print #I0, Trim$(Str$(Tags(I).TagPosStart)); vbTab;
  Print #I0, Trim$(Str$(Tags(I).TagPosEnd)); vbTab;
  Print #I0, IIf(Tags(I).TagOpen, "[x]", "[  ]"); vbTab;
  Print #I0, Trim$(Str$(Tags(I).TagOpenPosStart)); vbTab;
  Print #I0, Trim$(Str$(Tags(I).TagOpenPosEnd)); vbTab;
  Print #I0, IIf(Tags(I).TagClose, "[x]", "[  ]"); vbTab;
  Print #I0, Trim$(Str$(Tags(I).TagClosePosStart)); vbTab;
  Print #I0, Trim$(Str$(Tags(I).TagClosePosEnd)); vbTab;
  Print #I0, IIf(Tags(I).TagValue, "[x]", "[  ]"); vbTab;
  Print #I0, Trim$(Str$(Tags(I).TagValuePosStart)); vbTab;
  Print #I0, Trim$(Str$(Tags(I).TagValuePosEnd)); vbTab;
  Print #I0, vbSkip; vbTab;
  Print #I0, "0x" & Right$("0000" & Hex$(Tags(I).TagPosStart - 1), 4); vbTab;
  Print #I0, "0x" & Right$("0000" & Hex$(Tags(I).TagPosEnd - 1), 4); vbTab;
  Print #I0, IIf(Tags(I).TagOpen, "[x]", "[  ]"); vbTab;
  Print #I0, "0x" & Right$("0000" & Hex$(Tags(I).TagOpenPosStart - 1), 4); vbTab;
  Print #I0, "0x" & Right$("0000" & Hex$(Tags(I).TagOpenPosEnd - 1), 4); vbTab;
  Print #I0, IIf(Tags(I).TagClose, "[x]", "[  ]"); vbTab;
  Print #I0, "0x" & Right$("0000" & Hex$(Tags(I).TagClosePosStart - 1), 4); vbTab;
  Print #I0, "0x" & Right$("0000" & Hex$(Tags(I).TagClosePosEnd - 1), 4); vbTab;
  Print #I0, IIf(Tags(I).TagValue, "[x]", "[  ]"); vbTab;
  Print #I0, "0x" & Right$("0000" & Hex$(Tags(I).TagValuePosStart - 1), 4); vbTab;
  Print #I0, "0x" & Right$("0000" & Hex$(Tags(I).TagValuePosEnd - 1), 4); vbTab;
  Print #I0, IIf(AutoParseTag, Trim$(Str$(Tags(I).Attributes.Count)), vbSkip); vbTab;
  Print #I0, IIf(StoreText, Replace$(Tags(I).Text, vbNewLine, "\\"), vbNullString); vbTab;
  Print #I0, Replace$(Replace$(Replace$(Mid$(HTML, Tags(I).TagPosStart, Tags(I).TagPosEnd - Tags(I).TagPosStart + 1), vbCr, "{CR}"), vbLf, "{LF}"), vbTab, "{TAB}")
Next I
Close #I0
End Sub

Public Sub ParseTag(TagHTML As String, ByRef Tag As TagType, Optional ByVal CompactAttributes As Boolean = False)
Dim S As String, I0 As Long, I As Long, P As Long, N As Long, A As String, V As String
Const CharEqual As String = "=", CharQuotes As String = "'"""
S = TagHTML
Tag.Name = vbNullString
Tag.Count = 0
ReDim Tag.Fields(0)
ReDim Tag.Values(0)
If Left$(S, 1) = "<" And Right$(S, 1) = ">" Then
  S = Mid$(S, 2, Len(S) - 2)
ElseIf Left$(S, 1) = "<" Then
  S = Mid$(S, 2)
ElseIf Right$(S, 1) = ">" Then
  S = Mid$(S, 1, Len(S) - 1)
End If
If Right$(S, 1) = "/" Then S = Left$(S, Len(S) - 1)
If Left$(S, 1) = "/" Then Exit Sub
S = Replace$(S, vbCrLf, vbSpace)
S = Replace$(S, vbTab, vbSpace)
S = Replace$(S, vbCr, vbSpace)
S = Replace(S, vbLf, vbSpace)
S = Trim$(S)
If InStr(S, vbSpace) = 0 Then
  Tag.Name = UCase$(S)
  Exit Sub
End If
I0 = InStr(S, vbSpace) + Len(vbSpace)
Tag.Name = UCase$(Left$(S, I0 - Len(vbSpace) - 1))
Do Until I0 > Len(S)
  If fGlobalCancel Then
    Tag.Name = vbNullString
    Tag.Count = 0
    ReDim Tag.Fields(0)
    ReDim Tag.Values(0)
    Exit Do
  End If
  I = InStr(I0, S, vbSpace)
  If I = 0 Then I = Len(S) + 1
  N = InStr(I0, S, CharEqual)
  If N > 0 And N < I Then I = N
  If N > 0 Then
    If Len(Replace$(Mid$(S, I, N - I), vbSpace, vbNullString)) = 0 Then
      I = N
    Else
      N = 0
    End If
  End If
  A = Trim$(Mid$(S, I0, I - I0))
  V = vbNullString
  If N = 0 Then
    V = vbNullChar
    I0 = I + Len(vbSpace)
  Else
    I0 = N + Len(CharEqual)
    While Mid$(S, I0, Len(vbSpace)) = vbSpace
      I0 = I0 + 1
    Wend
    If InStr(CharQuotes, Mid$(S, I0, 1)) = 0 Then
      I = InStr(I0, S, vbSpace)
      If I = 0 Then I = Len(S) + 1
      V = Mid$(S, I0, I - I0)
      I0 = I + Len(vbSpace)
    Else
      I = InStr(I0 + 1, S, Mid$(S, I0, 1))
      If I = 0 Then I = Len(S) + 1
      V = Mid$(S, I0 + 1, I - I0 - 1)
      I0 = I + 1
    End If
  End If
  If Len(A) > 0 Then
    If CompactAttributes Then
      For N = 1 To Tag.Count
        If UCase$(A) = UCase$(Tag.Fields(N)) Then Exit For
      Next N
    Else
      N = Tag.Count + 1
    End If
    If N > Tag.Count Then
      N = UBound(Tag.Fields)
      Tag.Count = Tag.Count + 1
      If Tag.Count > N Then
        ReDim Preserve Tag.Fields(0 To N + 10)
        ReDim Preserve Tag.Values(0 To N + 10)
      End If
      N = Tag.Count
      Tag.Fields(N) = A
    End If
    Tag.Values(N) = V
  End If
Loop
ReDim Preserve Tag.Fields(0 To Tag.Count)
ReDim Preserve Tag.Values(0 To Tag.Count)
End Sub
